diff --git a/test/integration/setup_orchestration_test.rb b/test/integration/setup_orchestration_test.rb
new file mode 100644
index 000000000..64d1c93c6
--- /dev/null
+++ b/test/integration/setup_orchestration_test.rb
@@ -0,0 +1,223 @@
+require "test_helper"
+require "hive/commands/setup"
+require "hive/setup/preflight"
+require "hive/setup/daemon_guard"
+require "net/http"
+
+# U7 — `hive setup` orchestration: step ordering, idempotent re-runs, the
+# JSON summary envelope, partial-failure reporting, and the end-to-end web
+# step against a fixture HTTP server answering /health?deep=1.
+class SetupOrchestrationTest < Minitest::Test
+  include HiveTestHelper
+
+  def setup
+    @provision_calls = []
+    @fixture_app_dir = nil
+  end
+
+  def test_happy_path_runs_steps_and_prints_the_real_url
+    with_fixture_stack do |setup, port|
+      out, _err = capture_io { assert setup.call }
+
+      assert_match(/✔ preflight/, out)
+      assert_match(/✔ web_app/, out)
+      assert_match(/✔ daemon/, out)
+      assert_match(/✔ web/, out)
+      assert_match(%r{http://127.0.0.1:#{port}}, out) # the printed URL must be the real bound address
+    end
+  end
+
+  def test_json_envelope_reports_steps_ok_with_url
+    with_fixture_stack do |_setup, port|
+      setup = build_setup(port: port, json: true)
+      out, _err = capture_io { assert setup.call }
+      envelope = JSON.parse(out)
+
+      assert_equal "hive-setup", envelope.fetch("schema")
+      assert_equal true, envelope.fetch("ok")
+      names = envelope["steps"].map { |s| s["name"] }
+      assert_equal %w[preflight web_app daemon web], names & %w[preflight web_app daemon web]
+      assert_equal "skipped", envelope["steps"].find { |s| s["name"] == "enroll" }["status"]
+      assert envelope["steps"].all? { |s| s["status"] == "ok" || s["status"] == "skipped" }
+      assert_equal "http://127.0.0.1:#{port}", envelope.fetch("url")
+    end
+  end
+
+  def test_rerun_is_idempotent_no_reprovision
+    with_fixture_stack do |_setup, port|
+      @provision_calls.clear
+      setup = build_setup(port: port)
+      capture_io { assert setup.call }
+      downloads_before = @provision_calls.size
+
+      second = build_setup(port: port)
+      capture_io { assert second.call }
+
+      assert_equal downloads_before, @provision_calls.size,
+                   "re-running setup must not re-provision the web app"
+    end
+  end
+
+  def test_missing_hard_dependency_fails_preflight_but_web_step_still_completes
+    with_fixture_stack do |_setup, port|
+      broken_ruby = green_preflight("ruby -v" => [ "", false ])
+      setup = build_setup(port: port, preflight: broken_ruby)
+
+      out, _err = capture_io { refute setup.call, "a hard dependency failure must fail the run" }
+
+      assert_match(/✘ preflight/, out)
+      assert_match(/ruby/, out) # the broken row is named loudly
+      # Partial failure does not abort the remaining steps: web still
+      # verifies healthy and the URL is printed.
+      assert_match(/http:\/\/127\.0\.0\.1:#{port}/, out)
+    end
+  end
+
+  def test_port_conflict_is_reported_with_owner_and_never_killed
+    with_tmp_global_config do |dir|
+      port = free_port
+      write_global_web_port(dir, port)
+      # A foreign listener owns the port and stays alive throughout.
+      blocker = TCPServer.new("127.0.0.1", port)
+
+      setup = Hive::Commands::Setup.new(
+        skip_preflight: true, skip_daemon: true, skip_enroll: true,
+        provisioner: fake_provisioner
+      )
+      _out, _err = capture_io { refute setup.call }
+
+      web_step = setup.steps.find { |s| s.name == "web" }
+      assert_equal "failed", web_step.status
+      assert_match(/already taken by pid/, web_step.detail) # the conflict report must name the owning pid
+    ensure
+      blocker.close
+    end
+  end
+
+  private
+
+  # Full sandbox: HIVE_HOME + a fixture web server answering /health?deep=1
+  # on the configured port. Enrollment is skipped — covered by U6's suite.
+  def with_fixture_stack
+    with_tmp_global_config do |dir|
+      @provision_calls = []
+      @fixture_app_dir = File.join(Dir.mktmpdir("hive-setup-app"), "web-app")
+      FileUtils.mkdir_p(File.join(@fixture_app_dir, "config"))
+      File.write(File.join(@fixture_app_dir, "config", "application.rb"), "# fixture\n")
+      port = free_port
+      write_global_web_port(dir, port)
+      server = start_fixture_health_server(port)
+      setup = build_setup(port: port)
+      yield setup, port
+    ensure
+      server&.close
+      @fixture_thread&.kill
+    end
+  end
+
+  def build_setup(port:, preflight: nil, json: false)
+    Hive::Commands::Setup.new(
+      skip_preflight: false,
+      skip_enroll: true,
+      json: json,
+      preflight: preflight || green_preflight,
+      guard: fake_guard,
+      provisioner: fake_provisioner
+    ).tap do |setup|
+      # Force the provisioning path even inside a source checkout so the
+      # provisioner seam is actually exercised.
+      setup.define_singleton_method(:web_app_dir) { nil }
+    end
+  end
+
+  def green_preflight(overrides = {})
+    probes = {
+      "ruby -v" => [ "ruby 3.4.1\n", true ],
+      "git --version" => [ "git version 2.43.0\n", true ],
+      "bundle --version" => [ "Bundler version 2.5\n", true ],
+      "tmux -V" => [ "tmux 3.4\n", true ],
+      "node --version" => [ "v20.0.0\n", true ],
+      "npm --version" => [ "10.0.0\n", true ],
+      "claude --version" => [ "#{Hive::MIN_CLAUDE_VERSION}\n", true ],
+      "codex --version" => [ "codex-cli 0.9\n", true ],
+      "gh --version" => [ "gh version 2.62\n", true ],
+      "gh auth status" => [ "", true ],
+      "sqlite3 --version" => [ "3.45.0\n", true ]
+    }.merge(overrides)
+    Hive::Setup::Preflight.new(runner: ->(argv) { probes[argv.join(" ")] || [ "", false ] },
+                               qmd_finder: -> { "/fake/qmd" })
+  end
+
+  def fake_guard
+    check_result = Hive::Setup::DaemonGuard::Result.new(
+      status: "ok", running: true, pid: 42_424,
+      unit_path: "/fake/hive-daemon.service",
+      service_binary: "/fake/bin/hive", expected_binary: "/fake/bin/hive",
+      detail: nil
+    )
+    guard = Object.new
+    guard.define_singleton_method(:check) { check_result }
+    guard.define_singleton_method(:pid_file) { "" }
+    guard
+  end
+
+  def fake_provisioner
+    app_dir = @fixture_app_dir ||= File.join(Dir.mktmpdir("hive-setup-app"), "web-app")
+    FileUtils.mkdir_p(File.join(app_dir, "config"))
+    File.write(File.join(app_dir, "config", "application.rb"), "# fixture\n") unless File.file?(File.join(app_dir, "config", "application.rb"))
+    # Mirrors the real AppProvisioner contract: the on-disk marker file
+    # makes provisioning idempotent ACROSS setup runs (no re-download).
+    marker = File.join(app_dir, ".hive-provisioned")
+    calls = @provision_calls
+    Object.new.tap do |prov|
+      prov.define_singleton_method(:provision) do
+        calls << :provisioned unless File.exist?(marker)
+        FileUtils.touch(marker)
+        app_dir
+      end
+    end
+  end
+
+  # A tiny real HTTP server standing in for the Rails /health endpoint.
+  def start_fixture_health_server(port)
+    server = TCPServer.new("127.0.0.1", port)
+    @fixture_thread = Thread.new do
+      loop do
+        client = begin
+          server.accept
+        rescue StandardError
+          next
+        end
+        request = +""
+        while (line = client.gets) && line != "\r\n"
+          request << line
+        end
+        if request.start_with?("GET /health")
+          body = '{"ok":true}'
+          client.write("HTTP/1.1 200 OK\r\nContent-Type: application/json\r\nContent-Length: #{body.length}\r\n\r\n#{body}")
+        else
+          client.write("HTTP/1.1 404 Not Found\r\nContent-Length: 0\r\n\r\n")
+        end
+        client.close
+      rescue StandardError
+        next
+      end
+    end
+    server
+  end
+
+  def free_port
+    server = TCPServer.new("127.0.0.1", 0)
+    port = server.addr[1]
+    server.close
+    port
+  end
+
+  def write_global_web_port(dir, port)
+    path = File.join(dir, "config.yml")
+    data = File.exist?(path) ? YAML.safe_load_file(path) : {}
+    data["registered_projects"] ||= []
+    data["web"] = { "bind" => "127.0.0.1", "port" => port }
+    File.write(path, data.to_yaml)
+  end
+end
diff --git a/test/unit/cli_test.rb b/test/unit/cli_test.rb
index dafa1c291..ba38ffb8b 100644
--- a/test/unit/cli_test.rb
+++ b/test/unit/cli_test.rb
@@ -519,7 +519,7 @@ class HiveCliTest < Minitest::Test
     require "hive/commands/web"
     captured = []
     recorder = Class.new do
-      define_method(:initialize) { |bind:, port:| captured << { bind: bind, port: port } }
+      define_method(:initialize) { |bind:, port:, unsafe_public: false| captured << { bind: bind, port: port } }
       define_method(:call) { captured << :called }
     end
 
diff --git a/test/unit/commands/web/service_installer_test.rb b/test/unit/commands/web/service_installer_test.rb
new file mode 100644
index 000000000..574bcb74a
--- /dev/null
+++ b/test/unit/commands/web/service_installer_test.rb
@@ -0,0 +1,110 @@
+require "test_helper"
+require "hive/commands/web/service_installer"
+
+# U4 — managed web service unit rendering/installation, mirroring
+# DaemonServiceInstallerTest's shape. The web tier is its own unit
+# (`hive-web`), never merged with the daemon.
+class WebServiceInstallerTest < Minitest::Test
+  include HiveTestHelper
+
+  def test_linux_writes_systemd_unit_with_resolved_binary_and_web_verb
+    with_tmp_dir do |dir|
+      commands = []
+      hive = File.join(dir, "bin", "hive")
+      FileUtils.mkdir_p(File.dirname(hive))
+      File.write(hive, "#!/bin/sh\n")
+      FileUtils.chmod(0o755, hive)
+
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        host_os: "linux-gnu",
+        home: dir,
+        binary_path: hive,
+        systemctl_available: true,
+        runner: ->(argv) { commands << argv }
+      )
+
+      result = installer.install!(autostart: true)
+      assert_equal :written, result.kind
+      unit = File.join(dir, ".config/systemd/user/hive-web.service")
+      assert File.exist?(unit), "the web unit is separate from hive-daemon.service"
+      content = File.read(unit)
+      assert_includes content, "ExecStart=#{hive} web"
+      assert_includes content, "Environment=HIVE_BIN=#{hive}"
+      refute_includes content, "ExecStart=.*daemon"
+      refute_match(/^ExecStart=.*daemon/, content)
+      assert_equal %w[systemctl --user daemon-reload], commands[0]
+      assert_includes commands[1], "--now"
+      assert_includes commands[1], "hive-web"
+    end
+  end
+
+  def test_macos_writes_plist_with_local_hive_web_label
+    with_tmp_dir do |dir|
+      commands = []
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        host_os: "darwin23",
+        home: dir,
+        binary_path: "/opt/hive/bin/hive",
+        runner: ->(argv) { commands << argv }
+      )
+
+      result = installer.install!(autostart: true)
+      assert_equal :written, result.kind
+      plist = File.join(dir, "Library/LaunchAgents/local.hive-web.plist")
+      assert File.exist?(plist)
+      content = File.read(plist)
+      assert_includes content, "<string>local.hive-web</string>"
+      assert_includes content, "<string>/opt/hive/bin/hive</string>"
+      assert_includes content, "<string>web</string>"
+      assert_includes content, "#{dir}/Library/Logs/hive-web.out.log"
+      assert_includes commands, [ "launchctl", "load", plist ]
+    end
+  end
+
+  def test_drifted_unit_refuses_without_force_and_backs_up_with_force
+    with_tmp_dir do |dir|
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        host_os: "linux",
+        home: dir,
+        binary_path: "/tmp/hive",
+        systemctl_available: false,
+        runner: ->(_argv) { true }
+      )
+      # First install seeds the unit; hand-edit it to simulate drift.
+      installer.install!(autostart: false)
+      unit = File.join(dir, ".config/systemd/user/hive-web.service")
+      File.write(unit, File.read(unit) + "# hand edit\n")
+
+      drifted = installer.install!(autostart: false)
+      assert_equal :drifted, drifted.kind
+      assert installer.messages.any? { |msg| msg.include?("install --force") }
+
+      forced = installer.install!(autostart: false, force: true)
+      assert_equal :upgraded, forced.kind
+      assert_forced_backup_present(unit)
+    end
+  end
+
+  def test_unsupported_host_reports_unsupported_outcome
+    with_tmp_dir do |dir|
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        host_os: "mswin",
+        home: dir,
+        binary_path: "/tmp/hive"
+      )
+
+      result = installer.install!(autostart: true)
+      assert_equal :unsupported, result.kind
+      assert_equal "unsupported", installer.envelope_platform
+      assert installer.messages.any? { |msg| msg.include?("hive web") }
+    end
+  end
+
+  private
+
+  def assert_forced_backup_present(unit)
+    backups = Dir.glob("#{unit}.bak-*")
+    assert backups.size == 1, "expected exactly one timestamped backup, got #{backups.inspect}"
+    assert_includes File.read(backups.first), "# hand edit"
+  end
+end
diff --git a/test/unit/commands/web_auth_test.rb b/test/unit/commands/web_auth_test.rb
new file mode 100644
index 000000000..51750883a
--- /dev/null
+++ b/test/unit/commands/web_auth_test.rb
@@ -0,0 +1,166 @@
+require "test_helper"
+require "hive/commands/web"
+
+# U1 — effective auth-mode resolution and the non-loopback no-auth refusal
+# in `hive web`. Kernel.exec / db:prepare are stubbed so `call` is observed
+# without ever booting Rails.
+class WebAuthCommandTest < Minitest::Test
+  include HiveTestHelper
+
+  def test_loopback_default_resolves_auth_mode_none
+    with_tmp_global_config do |dir|
+      result = run_web(dir)
+
+      assert_nil result[:error]
+      assert_equal "none", result[:auth_mode]
+      assert_equal "none", result[:env].fetch("HIVEBOX_AUTH_MODE")
+    end
+  end
+
+  # Plan scenario 2 as literally written (--bind 0.0.0.0 + default auth ⇒
+  # refusal) conflicts with R16: the hivebox supervisor runs exactly
+  # `hive web --bind 0.0.0.0` with default config, and R16 pins that path.
+  # Per the plan's Approach text ("auto ... resolves to github exactly as
+  # today"), the refusal fires only when the EFFECTIVE auth mode is `none`.
+  def test_non_loopback_bind_with_default_auth_resolves_to_github
+    with_tmp_global_config do |dir|
+      result = run_web(dir, bind: "0.0.0.0")
+
+      assert_nil result[:error]
+      assert_equal "github", result[:auth_mode]
+    end
+  end
+
+  def test_non_loopback_bind_with_explicit_none_auth_is_refused
+    with_tmp_global_config do |dir|
+      File.write(File.join(dir, "config.yml"), {
+        "registered_projects" => [],
+        "web" => { "auth" => "none" }
+      }.to_yaml)
+
+      result = run_web(dir, bind: "0.0.0.0")
+
+      assert_instance_of Hive::Error, result[:error]
+      assert_match(/refusing to bind 0\.0\.0\.0 without authentication/, result[:error].message)
+      assert_match(/--bind 127\.0\.0\.1/, result[:error].message)
+      assert_match(/web\.auth: github/, result[:error].message)
+      assert_match(/--unsafe-public/, result[:error].message)
+    end
+  end
+
+  def test_non_loopback_bind_with_unsafe_public_starts_with_github_auth
+    with_tmp_global_config do |dir|
+      result = run_web(dir, bind: "0.0.0.0", unsafe_public: true)
+
+      assert_nil result[:error]
+      assert_equal "github", result[:auth_mode]
+    end
+  end
+
+  def test_non_loopback_bind_with_allow_public_unsafe_config_and_none_auth_boots
+    with_tmp_global_config do |dir|
+      File.write(File.join(dir, "config.yml"), {
+        "registered_projects" => [],
+        "web" => { "auth" => "none", "allow_public_unsafe" => true }
+      }.to_yaml)
+
+      result = run_web(dir, bind: "0.0.0.0")
+
+      assert_nil result[:error]
+      assert_equal "none", result[:auth_mode]
+    end
+  end
+
+  def test_explicit_github_auth_gates_even_on_loopback
+    with_tmp_global_config do |dir|
+      File.write(File.join(dir, "config.yml"), {
+        "registered_projects" => [],
+        "web" => { "auth" => "github" }
+      }.to_yaml)
+
+      result = run_web(dir)
+
+      assert_equal "github", result[:auth_mode]
+    end
+  end
+
+  def test_explicit_none_auth_with_non_loopback_config_bind_is_refused
+    with_tmp_global_config do |dir|
+      File.write(File.join(dir, "config.yml"), {
+        "registered_projects" => [],
+        "web" => { "bind" => "192.168.1.10", "auth" => "none" }
+      }.to_yaml)
+
+      result = run_web(dir)
+
+      assert_match(/refusing to bind 192\.168\.1\.10 without authentication/, result[:error].message)
+    end
+  end
+
+  def test_explicit_none_auth_with_non_loopback_bind_and_unsafe_flag_boots
+    with_tmp_global_config do |dir|
+      File.write(File.join(dir, "config.yml"), {
+        "registered_projects" => [],
+        "web" => { "bind" => "192.168.1.10", "auth" => "none" }
+      }.to_yaml)
+
+      result = run_web(dir, unsafe_public: true)
+
+      assert_nil result[:error]
+      assert_equal "none", result[:auth_mode]
+    end
+  end
+  def test_localhost_and_ipv6_loopback_binds_are_recognized
+    web = Hive::Commands::Web.new
+
+    %w[127.0.0.1 localhost ::1 LOCALHOST].each do |bind|
+      assert web.send(:loopback_bind?, bind), "#{bind} should count as loopback"
+    end
+    refute web.send(:loopback_bind?, "0.0.0.0")
+    refute web.send(:loopback_bind?, "192.168.1.10")
+  end
+
+  private
+
+  RunResult = Struct.new(:env, :auth_mode, :error)
+
+  # Runs Hive::Commands::Web#call against a fake app dir with the
+  # db:prepare system call and the final Kernel.exec stubbed out.
+  # Returns a RunResult with the env hash passed to exec, the resolved
+  # auth mode, and any typed Hive::Error raised on the refusal path.
+  def run_web(config_dir, bind: nil, unsafe_public: false)
+    app_dir = File.join(config_dir, "fake-web-app")
+    FileUtils.mkdir_p(File.join(app_dir, "config"))
+    FileUtils.mkdir_p(File.join(app_dir, "bin"))
+    File.write(File.join(app_dir, "config", "application.rb"), "# fixture\n")
+    File.write(File.join(app_dir, "bin", "rails"), "#!/bin/sh\n")
+
+    env_holder = {}
+    error = nil
+
+    original_exec = Kernel.method(:exec)
+    Kernel.define_singleton_method(:exec) do |*args|
+      env_holder.replace(args.first.is_a?(Hash) ? args.first : {})
+      raise SystemExit # unwind like a real exec path would
+    end
+
+    with_env("HIVEBOX_WEB_APP_DIR" => app_dir, "RAILS_ENV" => "test") do
+      web = Hive::Commands::Web.new(bind: bind, port: nil, unsafe_public: unsafe_public)
+      # Stub the private Kernel#system call used for db:prepare.
+      web.define_singleton_method(:system) { |*_args| true }
+      capture_io do
+        begin
+          web.call
+        rescue SystemExit
+          # expected on the success path
+        rescue Hive::Error
+          error = $ERROR_INFO
+        end
+      end
+    ensure
+      Kernel.define_singleton_method(:exec, original_exec)
+    end
+
+    RunResult.new(env_holder, env_holder["HIVEBOX_AUTH_MODE"], error)
+  end
+end
diff --git a/test/unit/commands/web_lifecycle_test.rb b/test/unit/commands/web_lifecycle_test.rb
new file mode 100644
index 000000000..117ae2e1b
--- /dev/null
+++ b/test/unit/commands/web_lifecycle_test.rb
@@ -0,0 +1,132 @@
+require "test_helper"
+require "hive/commands/web"
+
+# U4 — web service lifecycle round-trips (start/stop/status) on the
+# detached-pidfile fallback path (no systemd-user in CI), plus the
+# status envelope shape.
+class WebLifecycleTest < Minitest::Test
+  include HiveTestHelper
+
+  def test_status_json_reports_not_running_with_service_state
+    with_tmp_global_config do |dir|
+      command = Hive::Commands::Web.new
+      out = capture_io_json { ignore_failure { command.service_status(json: true) } }
+
+      assert_equal "hive-web-status", out.fetch("schema")
+      assert_equal false, out.fetch("running")
+      assert_equal false, out.fetch("service_installed")
+      assert_equal false, out.fetch("service_enabled")
+      assert_match(/hive-web\.service$/, out.fetch("unit_path"))
+      refute_empty out.fetch("resolved_binary")
+    end
+  end
+
+  def test_status_detects_running_pid_from_pidfile
+    with_tmp_global_config do |dir|
+      command = Hive::Commands::Web.new
+      FileUtils.mkdir_p(File.dirname(command.pid_file))
+      File.write(command.pid_file, command.pid_file_payload(Process.pid).to_yaml)
+
+      out = capture_io_json { command.service_status(json: true) }
+
+      assert_equal true, out.fetch("running")
+      assert_equal Process.pid, out.fetch("pid")
+    ensure
+      FileUtils.rm_f(command.pid_file)
+    end
+  end
+
+  def test_stop_and_start_round_trip_on_detached_path
+    with_tmp_global_config do |dir|
+      # A long-lived stand-in "web server" the lifecycle can stop.
+      sleeper = spawn("sleep", "30", pgroup: true)
+      command = Hive::Commands::Web.new
+      FileUtils.mkdir_p(File.dirname(command.pid_file))
+      File.write(command.pid_file, command.pid_file_payload(sleeper).to_yaml)
+
+      # The unit is not installed here, so stop takes the detached path.
+      command.stop_service!(json: false) rescue nil
+      wait_until { !process_alive?(sleeper) }
+
+      refute process_alive?(sleeper), "stop must TERM the detached web pid"
+      refute File.exist?(command.pid_file), "the stale pidfile must be cleaned up"
+    ensure
+      Process.kill("KILL", sleeper) rescue nil
+    end
+  end
+
+  def test_start_refuses_to_double_start_detached
+    with_tmp_global_config do |_dir|
+      command = Hive::Commands::Web.new
+      FileUtils.mkdir_p(File.dirname(command.pid_file))
+      File.write(command.pid_file, command.pid_file_payload(Process.pid).to_yaml)
+
+      _out, err = capture_io { command.send(:start_detached!) }
+
+      assert_match(/already running/, err)
+      # No second pidfile write clobbered our live entry.
+      assert_equal Process.pid, YAML.safe_load_file(command.pid_file)["pid"]
+    ensure
+      FileUtils.rm_f(Hive::Commands::Web.new.pid_file)
+    end
+  end
+
+  def test_install_drift_refusal_names_the_force_flag
+    with_tmp_global_config_and_home do |dir|
+      hive = File.join(dir, "bin", "hive")
+      FileUtils.mkdir_p(File.dirname(hive))
+      File.write(hive, "#!/bin/sh\n")
+      FileUtils.chmod(0o755, hive)
+
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        host_os: "linux",
+        home: dir,
+        binary_path: hive,
+        systemctl_available: true,
+        runner: ->(_argv) { true }
+      )
+      installer.install!(autostart: false)
+      unit = File.join(dir, ".config/systemd/user/hive-web.service")
+      File.write(unit, File.read(unit) + "# drift\n")
+
+      command = Hive::Commands::Web.new
+      e = assert_raises(Hive::Error) { capture_io { command.install_service!(force: false) } }
+
+      # install_service! builds its own installer anchored on the real HOME,
+      # so only assert the remediation contract, not the exact path.
+      assert_match(/--force/, e.message)
+      assert_match(%r{hive-web\.service}, e.message)
+    end
+  end
+
+  private
+
+  def process_alive?(pid)
+    Process.kill(0, pid)
+    true
+  rescue Errno::ESRCH
+    false
+  end
+
+  def wait_until(timeout: 5)
+    deadline = Time.now + timeout
+    until yield
+      return false if Time.now > deadline
+
+      sleep 0.05
+    end
+    true
+  end
+
+  def capture_io_json
+    out, _err = capture_io { yield }
+    JSON.parse(out)
+  end
+
+  def ignore_failure
+    yield
+  rescue Hive::Error
+    # service_status raises when not running (daemon parity); the caller
+    # already has the emitted envelope.
+  end
+end
diff --git a/test/unit/config_web_test.rb b/test/unit/config_web_test.rb
new file mode 100644
index 000000000..88b1561a4
--- /dev/null
+++ b/test/unit/config_web_test.rb
@@ -0,0 +1,73 @@
+require "test_helper"
+
+# Validation matrix for the local-mode web config keys (U1):
+# `web.auth` (auto | none | github) and `web.allow_public_unsafe`.
+class ConfigWebTest < Minitest::Test
+  include HiveTestHelper
+
+  def validate(web_block)
+    cfg = {
+      "web" => {
+        "bind" => "127.0.0.1",
+        "port" => 4567,
+        "origin" => "http://127.0.0.1:4567",
+        "auth" => "auto",
+        "allow_public_unsafe" => false,
+        "github" => { "owner" => nil, "client_id" => "client" }
+      }.merge(web_block)
+    }
+    Hive::Config.send(:validate_web_config!, cfg, "/tmp/fake-config.yml")
+  end
+
+  def test_defaults_are_loopback_auto_auth
+    defaults = Hive::Config::DEFAULTS.fetch("web")
+
+    assert_equal "auto", defaults.fetch("auth")
+    assert_equal false, defaults.fetch("allow_public_unsafe")
+    assert_equal "127.0.0.1", defaults.fetch("bind")
+  end
+
+  def test_valid_auth_modes_pass
+    %w[auto none github].each do |mode|
+      validate({ "auth" => mode })
+    end
+  end
+
+  def test_invalid_auth_mode_raises
+    e = assert_raises(Hive::ConfigError) { validate({ "auth" => "openid" }) }
+
+    assert_match(/must be one of \["auto", "none", "github"\]/, e.message)
+  end
+
+  def test_non_string_auth_mode_raises
+    e = assert_raises(Hive::ConfigError) { validate({ "auth" => true }) }
+
+    assert_match(/web\.auth/, e.message)
+  end
+
+  def test_allow_public_unsafe_boolean_passes
+    validate({ "allow_public_unsafe" => true })
+    validate({ "allow_public_unsafe" => false })
+  end
+
+  def test_non_boolean_allow_public_unsafe_raises
+    e = assert_raises(Hive::ConfigError) { validate({ "allow_public_unsafe" => "yes" }) }
+
+    assert_match(/web\.allow_public_unsafe .* must be a boolean/, e.message)
+  end
+
+  # Existing global configs (Docker boxes included) predate both keys — a
+  # deep_merge of defaults must leave them valid with auth resolving to auto.
+  def test_config_without_new_keys_is_valid_after_merge
+    with_tmp_global_config do |dir|
+      File.write(File.join(dir, "config.yml"), {
+        "web" => { "bind" => "0.0.0.0", "origin" => "https://box.example.com" }
+      }.to_yaml)
+
+      cfg = Hive::Config.load_global_web
+
+      assert_equal "auto", cfg.fetch("auth")
+      assert_equal false, cfg.fetch("allow_public_unsafe")
+    end
+  end
+end
diff --git a/test/unit/daemon_guard_test.rb b/test/unit/daemon_guard_test.rb
new file mode 100644
index 000000000..d40586bba
--- /dev/null
+++ b/test/unit/daemon_guard_test.rb
@@ -0,0 +1,141 @@
+require "test_helper"
+require "hive/setup/daemon_guard"
+
+# U5 — daemon binary/version consistency guard: match, drift, not-installed,
+# stale pid, unsupported host, and the --force repair round-trip.
+class DaemonGuardTest < Minitest::Test
+  include HiveTestHelper
+
+  def test_matching_unit_and_live_pid_is_ok
+    with_sandbox do |dir, hive, guard|
+      install_daemon_unit(dir, hive)
+      write_live_pidfile(guard)
+
+      result = guard.check
+
+      assert_equal "ok", result.status
+      assert result.running
+      assert result.healthy?
+    end
+  end
+
+  def test_unit_pointing_at_a_different_binary_is_drifted
+    with_sandbox do |dir, hive, guard|
+      install_daemon_unit(dir, "/usr/bin/hive")
+
+      result = guard.check
+
+      assert_equal "drifted", result.status
+      assert_equal "/usr/bin/hive", result.service_binary
+      assert_equal File.realpath(hive), result.expected_binary
+      assert_match(/daemon install --force/, result.detail)
+    end
+  end
+
+  def test_drifted_unit_repairs_to_resolved_binary_and_recheck_passes
+    with_sandbox do |dir, hive, guard|
+      install_daemon_unit(dir, "/usr/bin/hive")
+      assert_equal "drifted", guard.check.status
+
+      commands = []
+      # Repair re-runs the daemon installer with --force; stub the runner so
+      # no real systemctl is touched and capture the outcome.
+      repairing = Hive::Setup::DaemonGuard.new(
+        home: dir, binary_path: hive, host_os: "linux",
+        runner: ->(argv) { commands << argv; true },
+        systemctl_available: true
+      )
+      outcome = nil
+      capture_io { outcome = repairing.repair! }
+
+      assert outcome.success?
+      assert_includes commands, %w[systemctl --user daemon-reload]
+      assert_equal "ok", guard.check.status, "re-check passes after repair"
+      assert_equal File.realpath(hive), guard.check.service_binary
+    end
+  end
+
+  def test_missing_unit_is_not_installed
+    with_sandbox do |_dir, _hive, guard|
+      result = guard.check
+
+      assert_equal "not_installed", result.status
+      refute result.running
+    end
+  end
+
+  def test_stale_pidfile_reports_not_running_but_ok_binary
+    with_sandbox do |dir, hive, guard|
+      install_daemon_unit(dir, hive)
+      FileUtils.mkdir_p(File.dirname(guard.pid_file))
+      File.write(guard.pid_file, { "pid" => 2_147_000_000, "process_start_time" => nil, "_legacy" => true }.to_yaml)
+
+      result = guard.check
+
+      assert_equal "ok", result.status
+      refute result.running, "a stale/reused pid must not count as alive"
+    end
+  end
+
+  def test_unsupported_host_reports_unsupported
+    with_tmp_dir do |dir|
+      hive = File.join(dir, "hive")
+      File.write(hive, "#!/bin/sh\n")
+      FileUtils.chmod(0o755, hive)
+      guard = Hive::Setup::DaemonGuard.new(home: dir, binary_path: hive, host_os: "mswin")
+
+      result = guard.check
+
+      assert_equal "unsupported", result.status
+      assert_match(/manually/, result.detail)
+    end
+  end
+
+  def test_launchd_plist_binary_is_extracted
+    with_tmp_dir do |dir|
+      hive = File.join(dir, "hive")
+      File.write(hive, "#!/bin/sh\n")
+      FileUtils.chmod(0o755, hive)
+      guard = Hive::Setup::DaemonGuard.new(home: dir, binary_path: hive, host_os: "darwin23")
+      installer = Hive::Commands::Daemon::ServiceInstaller.new(
+        host_os: "darwin23", home: dir, binary_path: "/opt/other/hive"
+      )
+      installer.install!(autostart: false)
+
+      result = guard.check
+
+      assert_equal "drifted", result.status
+      assert_equal "/opt/other/hive", result.service_binary
+    end
+  end
+
+  private
+
+  def with_sandbox
+    with_tmp_dir do |dir|
+      hive = File.join(dir, "bin", "hive")
+      FileUtils.mkdir_p(File.dirname(hive))
+      File.write(hive, "#!/bin/sh\n")
+      FileUtils.chmod(0o755, hive)
+      # Sandbox the daemon pidfile location too (Paths.state_home derives
+      # from HIVE_HOME) so tests can't leak liveness into each other.
+      with_env("HIVE_HOME" => dir) do
+        guard = Hive::Setup::DaemonGuard.new(home: dir, binary_path: hive, host_os: "linux")
+        yield dir, hive, guard
+      end
+    end
+  end
+
+  def install_daemon_unit(dir, binary)
+    installer = Hive::Commands::Daemon::ServiceInstaller.new(
+      host_os: "linux", home: dir, binary_path: binary, systemctl_available: true,
+      runner: ->(_argv) { true }
+    )
+    installer.install!(autostart: false)
+  end
+
+  def write_live_pidfile(guard)
+    FileUtils.mkdir_p(File.dirname(guard.pid_file))
+    File.write(guard.pid_file, guard.pid_file_payload(Process.pid).to_yaml)
+  end
+end
